void debug(const string &in str) {
    if (!develepor) return;
    trace("[Debug] " + str);
}

void debugRef(const string &in str, ref@ r) {
    if (!develepor) return;
    array<uint64>@ uintArr = cast<array<uint64>>(r);
    if (uintArr !is null) {
        string msg = " : {";
        for (uint i = 0; i < uintArr.Length; i++) {
            msg += uintArr[i] + ", ";
        }
        msg += "}";
        debug(str + msg);
        return;
    }

    debug("Missing suport for debug type ref");
}

// adapt regarding needs, should never be called in final code
void specifikDebug(mapInfo@ mi) {
    debug("memory.Get(mi.campaignId).maps[0] is " + mi.name + " : " + ((memory.Get(mi.campaignId).maps[0] is mi) ? "true" : "false"));
}

debugType currentDebugType = debugType::none;
mapInfo@ currentDebugMap = mapInfo();
campaignInfo@ currentDebugCampaign = campaignInfo();

void debugMap(mapInfo@ dmi) {
    currentDebugMap = dmi;
    currentDebugType = debugType::map;
    selectedTab = menuTabs::debug;
}

void debugCampaign(campaignInfo@ dci) {
    currentDebugCampaign = dci;
    currentDebugType = debugType::campaign;
    selectedTab = menuTabs::debug;
}

enum debugType {
    none,
    map,
    campaign
}

void drawDebug() {
    if (currentDebugType == debugType::none) return;
    if (currentDebugType == debugType::map) {
        currentDebugMap.drawMapDebug();
    }
    if (currentDebugType == debugType::campaign) {
        currentDebugCampaign.drawCampaignDebug();
    }
}